<!DOCTYPE html>
<html lang="en">
<%- include('bases/head') -%>
<body>
<script>
    let notes = []

    const ws = io()

    let cur_id = 0

    let chosen = []

    $(document).ready(function () {
        get_current_user_id()
        get_data()
    })

    function start_auth() {
        $("#auth").modal('show')
    }

    function auth() {
        let username = $("#username")
        let pwd = $("#password")
        $.ajax({
            url: '/api/login/',
            dataType: 'text',
            method: 'POST',
            statusCode: {
                '200': (token) => {
                    token = token.split('"')[1]
                    document.cookie = `token=${token}`;
                    if (token !== '_') {
                        $("#auth").modal('hide')
                        get_data()
                        get_current_user_id()
                    }
                    username.removeClass('is-invalid')
                    pwd.removeClass('is-invalid')
                },
                '403': () => {
                    username.addClass('is-invalid')
                    pwd.addClass('is-invalid')
                }
            },
            data: {
                'username': username.val(),
                'password': pwd.val()
            }
        })
    }

    function fill_edit_form(el) {
        let elements = $(el.parentNode.parentNode).find('[data-data]')
        for (let element of elements)
            $(`[name="${element.getAttribute('data-data')}"]`).val(element.innerHTML)
        $("#type").val('edit')
        $("#submit_btn").html('Изменить')
        $("#cancel_btn").prop('hidden', false)
        $("#edit_btn").prop('hidden', true)
    }

    function fill_create_form() {
        $("#type").val('create')
        $("#submit_btn").html('Добавить')
        $("#cancel_btn").prop('hidden', true)
        $("#edit_btn").prop('hidden', false)
    }

    function get_cookie(name) {
        const value = `; ${document.cookie}`;
        const parts = value.split(`; ${name}=`);
        if (parts.length === 2) return parts.pop().split(';').shift();
        else return null
    }

    function get_data() {
        $.ajax({
            url: '/api/records',
            dataType: 'json',
            method: 'GET',
            beforeSend: function (xhr) {
                if (get_cookie(('token')))
                    xhr.setRequestHeader("Authorization", get_cookie('token'))
            },
            statusCode: {
                '401': () => {
                    start_auth()
                },
                '403': () => {
                    start_auth()
                }
            },
        }).done(function (data) {
            notes = data
            /*let container = document.getElementById('container')
            let generated_html = ''
            for (let record of data) {
                generated_html += `<div class="card mb-3"><p data-data="id" hidden>${record['id']}</p>` +
                    `<h3 class="card-header" data-data="header">${record['header']}</h3><div class="card-body">` +
                    `<p class="card-text" data-data="body">${record['body']}</p></div><div class="card-body d-inline-flex">` +
                    `<button class="btn btn-outline-info" onclick="fill_edit_form(this)" type="button">Редактировать</button>` +
                    `<form method="post" class="ms-2"><input name="id" value="${record['id']}" hidden><input name="type" value="delete" hidden>` +
                    `<button class="btn btn-outline-danger" type="button" onclick="delete_note(this)">Удалить</button></form></div>` +
                    `<div class="card-footer text-muted" data-data="date">${record['date']}</div></div>`
            }
            $(container).html(generated_html)*/
            let headers = document.getElementById('headers_container')
            for (let header of headers.children)
                if (headers.children[0] !== header)
                    header.remove()
            for (let username in data)
                if (username !== 'Self')
                    $(headers).append(`<li class="nav-item" role="presentation"><a class="nav-link" data-bs-toggle="tab" href="#${username.toLowerCase()}_page" role="tab" tabindex="-1">${username}</a></li>`)
            let bodies = document.getElementById('bodies_container')
            let to_add = ''
            for (let username in data) {
                if (username.toLowerCase() === 'self')
                    to_add += `<div class="tab-pane fade show active" id="${username.toLowerCase()}_page" role="tabpanel">`
                else
                    to_add += `<div class="tab-pane fade" id="${username.toLowerCase()}_page" role="tabpanel">`
                for (let record of data[username]) {
                    to_add += `<div class="card mb-3"><p data-data="id" hidden>${record['id']}</p>` +
                        `<h3 class="card-header" data-data="header">${record['header']}</h3><div class="card-body">` +
                        `<p class="card-text" data-data="body">${record['body']}</p></div><div class="card-body d-inline-flex">` +
                        `<button class="btn btn-outline-info" onclick="fill_edit_form(this)" type="button">Редактировать</button>` +
                        `<form method="post" class="ms-2"><input name="id" value="${record['id']}" hidden><input name="type" value="delete" hidden>` +
                        `<button class="btn btn-outline-danger" type="button" onclick="delete_note(this)">Удалить</button></form></div>` +
                        `<div class="card-footer text-muted" data-data="date">${record['date']}</div></div>`
                }
                to_add += '</div>'
            }
            $(bodies).html(to_add)
        })
    }

    function delete_note(el) {
        let id = $(el.parentNode.parentNode.parentNode).find('[data-data="id"]').text()
        $.ajax({
            url: '/api/records/',
            data: {'id': id},
            method: 'DELETE',
            beforeSend: function (xhr) {
                if (get_cookie(('token')))
                    xhr.setRequestHeader("Authorization", get_cookie('token'))
            },
            statusCode: {
                '401': () => {
                    start_auth()
                },
                '403': () => {
                    start_auth()
                }
            },
        })
        $(el.parentNode.parentNode.parentNode).remove()
    }

    function edit_note() {
        let data = {}
        let elements = $("#form").find('[name]')
        for (let el of elements) {
            data[el.getAttribute('name')] = el.value
        }
        if (data['type'] === 'edit') {
            $.ajax({
                url: '/api/records/',
                method: 'PUT',
                data: data,
                beforeSend: function (xhr) {
                    if (get_cookie(('token')))
                        xhr.setRequestHeader("Authorization", get_cookie('token'))
                },
                statusCode: {
                    '401': () => {
                        start_auth()
                    },
                    '403': () => {
                        start_auth()
                    }
                },
            })
            $("#submit_btn").html('Добавить')
            get_data()
            $("#type").val('create')
        }
    }

    function create_note() {
        let data = {}
        let elements = $("#form").find('[name]')
        for (let el of elements) {
            data[el.getAttribute('name')] = el.value
        }
        if (data['type'] === 'create') {
            $.ajax({
                url: '/api/records/',
                method: 'POST',
                data: data,
                beforeSend: function (xhr) {
                    if (get_cookie(('token')))
                        xhr.setRequestHeader("Authorization", get_cookie('token'))
                },
                statusCode: {
                    '401': () => {
                        start_auth()
                    },
                    '403': () => {
                        start_auth()
                    }
                },
            })
            get_data()
        }
    }

    function sort_notes() {
        let order = $("#order").val()
        let field = $("#field").val()
        let name = $("#name").val()
        let records = notes
        for (let username in records)
            records[username].sort(function (a, b) {
                let x = a[field], y = b[field]
                if (order === 'asc')
                    return ((x < y) ? -1 : ((x > y) ? 1 : 0))
                else return ((x > y) ? -1 : ((x < y) ? 1 : 0))
            })
        let ret = {}
        for (let username in records)
            ret[username] = []
        if (name !== '') {
            for (let username in records)
                for (let temp of records[username]) {
                    if (temp['header'].includes(name) || temp['body'].includes(name) || temp['date'].includes(name))
                        ret[username].push(temp)
                }
        } else ret = records

        let bodies = document.getElementById('bodies_container')
        let to_add = ''
        for (let username in ret) {
            if (username.toLowerCase() === 'self')
                to_add += `<div class="tab-pane fade show active" id="${username.toLowerCase()}_page" role="tabpanel">`
            else
                to_add += `<div class="tab-pane fade" id="${username.toLowerCase()}_page" role="tabpanel">`
            for (let record of ret[username]) {
                to_add += `<div class="card mb-3"><p data-data="id" hidden>${record['id']}</p>` +
                    `<h3 class="card-header" data-data="header">${record['header']}</h3><div class="card-body">` +
                    `<p class="card-text" data-data="body">${record['body']}</p></div><div class="card-body d-inline-flex">` +
                    `<button class="btn btn-outline-info" onclick="fill_edit_form(this)" type="button">Редактировать</button>` +
                    `<form method="post" class="ms-2"><input name="id" value="${record['id']}" hidden><input name="type" value="delete" hidden>` +
                    `<button class="btn btn-outline-danger" type="button" onclick="delete_note(this)">Удалить</button></form></div>` +
                    `<div class="card-footer text-muted" data-data="date">${record['date']}</div></div>`
            }
            to_add += '</div>'
        }
        $(bodies).html(to_add)
    }

    function get_all_notes() {
        let note_elements = $('#container').children()
        let data = []
        let tmp
        let fields
        for (let el of note_elements) {
            fields = $(el).find('[data-data]')
            tmp = {}
            for (let field of fields) {
                tmp[field.getAttribute('data-data')] = field.innerHTML
            }
            data.push(tmp)
        }
        return data
    }

    function check_if_user_exists(elem) {
        $.ajax({
            url: '/api/users/',
            method: 'GET',
            dataType: 'json',
            data: {
                'username': elem.value
            }
        }).done(function (data) {
            if (data['exists']) {
                elem.classList.remove('is-valid')
                elem.classList.add('is-invalid')
            } else {
                elem.classList.remove('is-invalid')
                elem.classList.add('is-valid')
            }
        })
    }

    function validate_passwords(parent) {
        let pwd_1 = parent.children[1]
        let pwd_2 = parent.children[2]
        if (pwd_1.value === pwd_2.value) {
            pwd_1.classList.remove('is-invalid')
            pwd_1.classList.add('is-valid')
            pwd_2.classList.remove('is-invalid')
            pwd_2.classList.add('is-valid')
        } else {
            pwd_1.classList.remove('is-valid')
            pwd_1.classList.add('is-invalid')
            pwd_2.classList.remove('is-valid')
            pwd_2.classList.add('is-invalid')
        }
    }

    function create_user() {
        let username = document.getElementById('reg_username').value
        let pwd = document.getElementById('reg_password_1').value
        $.ajax({
            url: '/api/users/',
            method: 'POST',
            data: {
                'username': username,
                'password': pwd
            }
        })
    }

    function get_current_user_id() {
        $.ajax({
            url: '/api/users/this',
            dataType: 'json',
            method: 'GET',
            beforeSend: function (xhr) {
                if (get_cookie(('token')))
                    xhr.setRequestHeader("Authorization", get_cookie('token'))
            },
            statusCode: {
                '401': () => {
                    start_auth()
                },
                '403': () => {
                    start_auth()
                }
            },
        }).done(function (data) {
            cur_id = data.id
        })
    }

    function get_user_list() {
        $.ajax({
            'url': '/graph/',
            'method': 'POST',
            'dataType': 'json',
            'data': {
                'query': `{ access(user_id: ${cur_id}) { id username added } }`
            }
        }).done(function (data) {
            let sel = $("#sharing_target")
            let html = ''
            let tmp = data.data.access
            for (let user of tmp)
                if (user.id !== cur_id) {
                    html += `<option value="${user.id}"${user.added ? ' selected' : ''}>${user.username}</option>`
                    chosen.push(user.id)
                }
            sel.html(html)
        })
    }

    function process_access_change(element) {
        let cur = $(element).val()
        let to_add = []
        for (let entry in cur)
            if (!chosen.includes(entry))
                to_add.push(entry)
        let to_del = []
        for (let entry in chosen)
            if (!cur.includes(entry))
                to_del.push(entry)
        for (let entry of to_add)
            ws.emit('add_owner', {owner: cur_id, target: entry})
        for (let entry of to_del)
            ws.emit('delete_owner', {owner: cur_id, target: entry})
    }
</script>
<div class="d-flex justify-content-between w-75 m-auto vh-100 pt-5 flex-wrap row">
    <div class="col-lg-7">
        <form method="post" id="form">
            <input name="id" hidden>
            <input name="type" value="create" id="type" hidden>
            <div class="input-group">
                <input class="form-control form-control-lg" type="date" required name="date">
                <input class="form-control form-control-lg" type="text" placeholder="Заголовок..." name="header"
                       autocomplete="off">
            </div>
            <textarea class="form-control form-control-lg mt-3 no-resize" rows="10"
                      placeholder="Дорогой дневник..." name="body"></textarea>
            <div class="d-flex justify-content-around mt-3" id="form_buttons">
                <button class="btn btn-lg btn-outline-warning" type="reset" id="edit_btn" onclick="">Сбросить</button>
                <button class="btn btn-lg btn-outline-danger" type="reset" onclick="fill_create_form()" id="cancel_btn"
                        hidden>Отменить изменения
                </button>
                <button class="btn btn-lg btn-outline-success" type="reset" id="submit_btn"
                        onclick="edit_note(); create_note()">Добавить
                </button>
            </div>
        </form>
        <form class="mt-5" method="get">
            <div class="input-group">
                <div class="input-group-text">Сортировка:</div>
                <input hidden name="type" value="sort">
                <select class="form-control" id="order">
                    <option value="asc">По возрастанию</option>
                    <option value="desc">По убыванию</option>
                </select>
                <select class="form-control" id="field">
                    <option value="header">Заголовка</option>
                    <option value="body">Содержания</option>
                    <option value="date">Даты</option>
                </select>
                <div class="input-group-text">Поиск:</div>
                <input class="form-control" id="name" autocomplete="off">
                <button class="btn btn-outline-primary" type="button" onclick="sort_notes()">Применить</button>
                <button class="btn btn-outline-warning" type="button" onclick="this.form.reset(); sort_notes()">Сбросить
                </button>
            </div>
        </form>
    </div>
    <div class="col-lg-5 h-75 overflow-auto">
        <ul class="nav nav-tabs" role="tablist" id="headers_container">
            <li class="nav-item dropdown">
                <a class="nav-link dropdown-toggle active" data-bs-toggle="dropdown" href="#" role="button">Self</a>
                <div class="dropdown-menu" style="">
                    <a class="dropdown-item active" data-bs-toggle="tab" href="#self_page">View</a>
                    <a class="dropdown-item" data-bs-toggle="modal" data-bs-target="#sharing" onclick="get_user_list()">Share</a>
                </div>
            </li>
        </ul>
        <div class="tab-content" id="bodies_container">
            <div class="tab-pane fade show active" id="self_page" role="tabpanel"></div>
        </div>
    </div>
</div>
<div class="modal fade" id="auth" aria-hidden="true" data-bs-backdrop="static" data-bs-keyboard="false">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">Auth</h5>
            </div>
            <div class="modal-body">
                <form class="d-flex justify-content-between">
                    <input class="form-control w-50" placeholder="Username" type="text" id="username">
                    <input class="form-control w-50" placeholder="Password" type="password" id="password">
                </form>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#registration">
                    Register
                </button>
                <button type="button" class="btn btn-primary" onclick="auth()">Login</button>
            </div>
        </div>
    </div>
</div>
<div class="modal fade" id="registration" aria-hidden="true" data-bs-backdrop="static" data-bs-keyboard="false">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">Registration</h5>
            </div>
            <div class="modal-body">
                <form class="d-flex justify-content-between">
                    <input class="form-control w-50" placeholder="Username" type="text" id="reg_username"
                           onchange="check_if_user_exists(this)">
                    <input class="form-control w-50" placeholder="Password" type="password" id="reg_password_1"
                           onchange="validate_passwords(this.parentNode)">
                    <input class="form-control w-50" placeholder="Password (again)" type="password" id="reg_password_2"
                           onchange="validate_passwords(this.parentNode)">
                </form>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-bs-toggle="modal" data-bs-target="#auth">Return
                </button>
                <button type="button" class="btn btn-primary" onclick="create_user()" data-bs-toggle="modal"
                        data-bs-target="#auth">Register
                </button>
            </div>
        </div>
    </div>
</div>
<div class="modal fade" id="sharing" aria-hidden="true" data-bs-backdrop="static" data-bs-keyboard="false">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">Sharing</h5>
            </div>
            <div class="modal-body">
                <form class="d-flex justify-content-center">
                    <select class="form-control w-50" id="sharing_target" multiple
                            onchange="process_access_change(this)"></select>
                </form>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>
</body>
</html>